//wersja 3.2
//poprawiono nr ekranu w ktorym nastepuje kasowanie parametrow calosciowych
//dodano mozliwosc natychmiastowego zapisu parametrow przebytej trasy
//		(klawisz ESC w czasie postoju)

/*

***************************************************************************

 Program komputerka pokadowego do samochodu

 (C) Dariusz Kowalewski 2004

 darek3759@tlen.pl

***************************************************************************

format wypisywania liczby integer
nr bajtu w buforze  0  1  2  3  4  5  6
wartosc             x  x  x  x  .  x  0

format wypisywania liczby long int
nr bajtu w buforze  0  1  2  3  4  5  6  7  8  9  10
wartosc             x  x  x  x  x  x  x  x  x  x  0

*/
#pragma ROM (compact)


#include "mainprg.h"
#include "lcd.h"
#include "menu.h"

bit zamiana;

#include "meastemp.c"
#include "1wire.c"


#define temp_chip 0

//usigned long to 32 bity czyli 4 294 967 295

unsigned long dlugosc_trasy;      //dlugosc trasy liczona w impulsach
unsigned int wl_dlug_trasy;		//dlugosc trasy w 0.1km

byte ogolne_ilosc_paliwa_l;		//najmlodsze 8 bitow
unsigned long ogolne_ilosc_paliwa; //ilosc paliwa zuzyta od wlaczenia zasilania

unsigned int trasa_ilosc_paliwa; //ilosc paliwa zuzyta w trasie w 0.1l

byte trasa_czas_wtrysku_l;		//najmlodsze 8 bitow
unsigned long trasa_czas_wtrysku; //ilosc pliwa zuzyta w trasie w sumie czasow wtrysku

unsigned int  wspolczynnik_wtrysku; // impuls*256/0.1litr

unsigned long czas_wtrysku_kalibracyjny;  //ilosc impulsow ktora zostala zarejestrowana w czasie kalibracji

unsigned long chwilowa_ilosc_paliwa; // impuls/0.1litr
unsigned long pam_chwilowa_ilosc_paliwa; // impuls/0.1litr

unsigned long dlugosc_calkowita;  //dlugosc calkowita liczona w impulsach
unsigned long dlugosc_kalibracyjna;  //dlugosc calkowita potrzebna do skalibrowania wspolczynnika drogi liczona w impulsach
unsigned int dlugosc_wirtualna;  //licznik dlugosci prejechanej w odcinku czasu w impulsach
unsigned int dlugosc_chwilowa;   //dlugosc przejechana w odcinku czasu w impulsach
byte wspolczynnik_dlugosci;      //dlugosc drogi w cm na 1 impuls
unsigned int max_predk_trasa;   //maksymalna predkosc zarejestrowana w trasie w xx.xkm/h

unsigned int idata bak_paliwo;  //ilosc paliwa w baku na poczatku trasy
unsigned int idata bak_paliwo_temp;  //ilosc paliwa aktualnie w baku

byte pom100;
int temp1;
byte ii;
byte poprz_znak,akt_znak;

unsigned int czas_postoju;

byte max_czas_przerw;		//maksymalny czas przerwy w (min) w trasie
byte idata wynik[11];



bit jednasekunda;
bit pisz_ekran;
bit postoj;			//rozroznienie jedziemy / stoimy
bit powyzej5km;			//rozroznienie czy liczymy zuzycie w l/km czy w l/h
bit czuwaj;
bit kal_drogi,kal_wtrysku;
bit size;
bit invert;
bit scisnij;


byte nr_ekranu;
unsigned int predkosc_chwilowa;
byte idata prev_hour;

byte chwilowe_obroty;
byte idata pam_chwilowe_obroty;
byte czas_pisk;

byte day,month,year;  //idata zmienne zegara globalnego

byte akt_hour,akt_min,akt_sek;		//idata aktualnie liczony czas trasy


byte pocz_year,pocz_month,pocz_day,pocz_hour,pocz_min; //idata czas i data rozpoczecia trasy
byte pam_hour,pam_min,pam_sek;		//zapamietany czas trwania trasy


// day<1..31>, month<1..12>, year<0..99>

code unsigned char max_day[]={31,28,31,30,31,30,31,31,30,31,30,31};



#if temp_chip==1
void displaadc(void)
 {
 byte tl;
    // conversion result ready
    // a value of 80h in AD1H=0degC
	  //  80h=0, FFh=+127, 00h=-128
	tl= ADC1H-0x80;
	if( tl != 0x80 ){
     if( tl & 0x80 ){
      LcdChr ('-');
	  tl= -tl;
	 }
	 else LcdChr (' ');

	 LcdChr ((tl / 10));
	 LcdChr ((tl % 10));
	 tl=ADC1L;
	 LcdChr ('.');
	 LcdChr (((((tl >> 4 ) & 0xf)*10) >> 4));	// 0.5C
		}
	LcdStr("@C");
	RDY1=0;
 }
#endif

void piszbyte2( byte t )
{
 if( t >= 100 ){
  LcdStr ("??");
 }
 else{
  LcdChr ((t / 10));
  LcdChr ((t % 10));
 }
 }

void pisz_ulong(unsigned long liczba )

//10 pozycji xxxxxxxxxx
//nr bajtu w buforze  0  1  2  3  4  5  6  7  8  9  10
//wartosc             x  x  x  x  x  x  x  x  x  x  0

{

 for ( ii = 10; ii!=0;  ){
   --ii;
	 wynik[ii]=(liczba % 10)+48;
	 liczba=liczba/10;
 }

 wynik[10]=0;

 for ( ii = 0; ii < 9; ++ii ){
   if (wynik[ii]=='0') wynik[ii]=' ';
	 else return;
 }

}

void pisz_uint(unsigned int liczba)
//5 pozycji  xxxx.x
{

 for ( ii = 5; ii!=0;  ){
   --ii;
	 wynik[ii]=(liczba % 10)+48;
	 liczba=liczba/10;
 }

 wynik[5]=wynik[4];
 wynik[4]='.';
 wynik[6]=0;

 for ( ii = 0; ii < 3; ++ii ){
   if (wynik[ii]=='0') wynik[ii]=' ';
	 else return;
 }

}

void int_Timer1(void) interrupt 3
{
//	RXD=!RXD;
	TXD=!TXD;
}


//void int_RS(void) interrupt 4
//{
//	TI=0;
//	RI=0;				//na wszelki wypadek
//	SBUF=0x55;
//}



void int_TIC(void) interrupt 10 //using 2

// przerwanie czasowe co 1s
{
 TIMECON = TIMECON & 0xfb; //wyzerowanie wskaznika przerwania
 jednasekunda = 1;
 dlugosc_chwilowa = dlugosc_wirtualna;
 dlugosc_wirtualna=0;
 pam_chwilowa_ilosc_paliwa=chwilowa_ilosc_paliwa;
 chwilowa_ilosc_paliwa=0;
 pam_chwilowe_obroty=chwilowe_obroty;
 chwilowe_obroty=0;

  if ((((byte*)&czas_postoju)[0] & ((byte*)&czas_postoju)[1]) !=0xff) czas_postoju++;
 if (!postoj)  czas_postoju=0;



}

static byte keystat;

void int_tim2(void) interrupt 5 using 1
{
byte key;

#if test==1
	wtrysk=1;
	wtrysk1=1;
#endif

	if ( TF2 ) {
	czas_pisk--;
	if ( czas_pisk==0 ){
				ET1=0;
//				RXD=0;
				TXD=0;
	}

#if test==1

 dlugosc_trasy++;
 dlugosc_calkowita++;
 dlugosc_wirtualna++;
 for ( key=0; key<254; key++)
 {
	wtrysk=1;
 }
 for ( key=0; key<254; key++)
 {
	wtrysk=1;
 }

#endif

			TF2=0;
//	keystat; bit 1,0 = keycode, bit 2..7 = repeat counter

		key = (~P0^0 | 0x04) & 0x07;

  if( ((key ^ keystat) & 3) == 0 ){		// debouncing
    if( key != 4 ){
        if (keystat < 0xf0) keystat = keystat + 4 ;
        goto dalszy_kod;
		}
  }
	if( key != 4 )	keystat = key - 4;
		else{
		key=keystat & 0xfd;
		keystat=keystat & 0x3;
		if ((key <120)&&(key !=0)) nacisniety_klawisz= keystat;
		if (key >=120) nacisniety_klawisz=keystat+3;
		keystat=0;
		}

	}
dalszy_kod:

#if test==1
wtrysk=0;
wtrysk1=0;
#endif

	if ( EXF2 ) {
	   EXF2=0;

		chwilowe_obroty++;

		//zapamietaj wartosc licznika T1

		ogolne_ilosc_paliwa_l=ogolne_ilosc_paliwa_l+TL0;

		if ( CY ) ogolne_ilosc_paliwa++;				//uwaga nie przenaszalny element kodu
		ogolne_ilosc_paliwa=ogolne_ilosc_paliwa+TH0;

		trasa_czas_wtrysku_l=trasa_czas_wtrysku_l+TL0;
		if ( CY ) trasa_czas_wtrysku++;				//uwaga nie przenaszalny element kodu
		trasa_czas_wtrysku=trasa_czas_wtrysku+TH0;

		chwilowa_ilosc_paliwa=chwilowa_ilosc_paliwa+(TL0 | (unsigned int)TH0 << 8);

		TL0=0;
		TH0=0;

	}


}



void intext1(void) interrupt 2 using 1

// przerwanie od impulsow predkosciomierza

{
 dlugosc_trasy++;
 dlugosc_calkowita++;
 dlugosc_wirtualna++;
}





void policz_ilosc_paliwa_trasa(void)
{
// 1 impuls = 0.95367431640625us

//    xx.xl         impuls*256            impuls*256/0.1l           aby uzyskac z dokladnoscia 0.1km
trasa_ilosc_paliwa=(trasa_czas_wtrysku*10)/wspolczynnik_wtrysku;
}

void policz_dlugosc_trasy(void)
{
// UWAGA DLUGOSC TRASY NIE MOZE PRZEKROCZYC 5000km BO NASTAPI PRZEPELNIENIE MNOZENIA
// xxx.xkm       impuls          cm/impuls           aby uzyskac z dokladnoscia 0.1km
wl_dlug_trasy= dlugosc_trasy * wspolczynnik_dlugosci/80000;
 }

void policz_srednia_trasy(void)
{
 wl_dlug_trasy=(((((trasa_czas_wtrysku*wl_dlug_trasy)/wspolczynnik_wtrysku)*ii*100)/dlugosc_trasy)*80)/wspolczynnik_dlugosci;
}


void obsluga_ekranow(void)
{
	if ( pisz_ekran || postoj) LcdClear();

	pisz_ekran=0;

	if ( postoj ) return;

	switch ( nr_ekranu )	{

//=============================================================================
//         ekran postawowy 0
//=============================================================================
	 case 0:
	   LcdGotoXY(0x12);
	   size=1;
	   LcdStr ("       ");
	   LcdGotoXY(0x12);


// przypomnienie ze od 1 listopada do 1 marca nalezy wlaczyc swiatla mijania

				if (!((month>2) && (month<10)) && (!jasnosc)) {
					if ( SEC & 0x01 ) {
						LcdStr ("SWIATLA");
				czas_pisk=15;	//dzwiek ostrzegawczy na 300ms
				ET1=1;			//wlacz
					}
			 	size=0;
				}
				else {

				if (powyzej5km) {
// moment krytyczny podatny na bledy zaokraglania

				wl_dlug_trasy=25;
	  		ii=5*8;
				if (pam_chwilowa_ilosc_paliwa>34000) {
					wl_dlug_trasy=125*8;
					ii=1;
				}
	pisz_uint(((((pam_chwilowa_ilosc_paliwa*3125*ii)/wspolczynnik_wtrysku)*wl_dlug_trasy))/(dlugosc_chwilowa*wspolczynnik_dlugosci));
				}
				else	{

	pisz_uint((pam_chwilowa_ilosc_paliwa*2250)/(wspolczynnik_wtrysku*16ul)); //14.0625=3600/256=225/16
				}

					if (wynik[2] == ' ') wynik[2]='0';
					wynik[4]=wynik[3];
					wynik[3]='.';
					wynik[0]=wynik[5];
					wynik[5]=0;
					LcdStr_d(&wynik[1]);
					size=0;

					if (powyzej5km)  LcdStr ("l/100km");
					else LcdStr ("l/hour ");

					LcdGotoXY(0x81);
					LcdChr (wynik[0]);

#if test==0
				if (kal_drogi) {
				 LcdGotoXY(0xd1);
				 invert=1;
				 LcdChr ('d'); //zaznaczenie ze trwa kalibracja wspolczynnika drogi
				}

				if (kal_wtrysku) {
				 LcdGotoXY(0xe1);
				 invert=1;
				 LcdChr ('w'); //zaznaczenie ze trwa kalibracja wspolczynnika wtrysku
				}
#endif
				}

				LcdGotoXY(0x13);

				piszbyte2(akt_hour);
  			LcdChr (':');
  			piszbyte2(akt_min);
  			LcdChr (':');
  			piszbyte2(akt_sek);

				pisz_uint((ADC0H*(unsigned int)6)/10);
				LcdStr_d (&wynik[1]);  // od 1 bo spacja przerwy
				LcdChr('V');
			 	RDY0=0;  				//ponowne wyzwolenie przetwornika A/C

				LcdGotoXY(0x14);
			 	policz_ilosc_paliwa_trasa();
				pisz_uint(trasa_ilosc_paliwa); //wypisanie zuzytego paliwa w trasie
				wynik[4]=wynik[3];
				wynik[3]='.';
				if (wynik[2]==' ') wynik[2]='0';
				LcdStr_d (&wynik[1]);
			 	LcdChr ('l');

				policz_dlugosc_trasy();
				pisz_uint(wl_dlug_trasy); //wypisanie przejechanej w trasie odleglosci
				LcdStr_d (&wynik[0]); // od 0 bo spacja przerwy
				LcdStr ("km");

//				LcdGotoXY(0x15);
				LcdStr("zew ");

				displaytemp(outdoor);

				LcdChr (poprz_znak);
				LcdChr (akt_znak);
											//3 stopnie Celsjusza 3*16
			 	LcdChr (' ');
				LcdGotoXY(0xe5);
				if (( outdoor <= 3*16) && ( SEC & 0x01 )) {
				 	LcdChr ('*');
				 }
#if test==0
				LcdGotoXY(0x16);
				LcdStr("wew ");
				displaytemp(indoor);
#endif
				break;


//=============================================================================
//         ekran dodatkowy 1 duze cyfry parametrow trasy
//=============================================================================

		case 1:

				LcdGotoXY(0x12);
				size=1;
				piszbyte2(akt_hour);


				scisnij=1;
				LcdChr (':');
				scisnij=0;
				piszbyte2(akt_min);
				scisnij=1;
				LcdChr (':');
				scisnij=0;
				piszbyte2(akt_sek);

				LcdGotoXY(0x14);
				policz_dlugosc_trasy();
				pisz_uint(wl_dlug_trasy); //wypisanie przejechanej w trasie odleglosci

				LcdStr_d (&wynik[1]); // od 0 bo spacja przerwy
				LcdStr ("km");

				LcdGotoXY(0x16);
			 	policz_ilosc_paliwa_trasa();
				pisz_uint(trasa_ilosc_paliwa); //wypisanie zuzytego paliwa w trasie
					wynik[4]=wynik[3];
					wynik[3]='.';
					if (wynik[2]==' ') wynik[2]='0';
					LcdStr_d (&wynik[1]);
			 	LcdChr ('l');
				size=0;
				LcdGotoXY(0x11);
				break;

//=============================================================================
//         ekran dodatkowy 2 dodatkowe informacje o trasie
//=============================================================================

		case 2:



				LcdGotoXY(0x11);
				LcdStr("Sr.t");
				pisz_uint((dlugosc_trasy * wspolczynnik_dlugosci)/(akt_hour*(unsigned long)80000+((akt_min*(unsigned long)8000)/6)+((akt_sek*(unsigned long)800)/36)));
				LcdStr_d(&wynik[0]);	//od zera bo spacja rozdzielajaca
				LcdStr("km/h");

#if test==0
				LcdGotoXY(0x12);
				LcdStr("==============");
#endif

//				LcdGotoXY(0x13);
				LcdStr("Mx.t");
				pisz_uint(max_predk_trasa);
				LcdStr_d(&wynik[0]);	//od zera bo spacja rozdzielajaca
				LcdStr("km/h");

#if test==0
				LcdGotoXY(0x14);
				LcdStr("==============");
#endif

//				LcdGotoXY(0x15);
				LcdStr("Sr");
 // moment krytyczny podatny na bledy zaokraglania
				wl_dlug_trasy=10000;
				ii=1;
				if ( ( ((byte*)&trasa_czas_wtrysku)[0] | ((byte*)&trasa_czas_wtrysku)[1] ) !=0) {
					wl_dlug_trasy=100;
					ii=100;
				}
if ((((byte*)&dlugosc_trasy)[0] | ((byte*)&dlugosc_trasy)[1] | ((byte*)&dlugosc_trasy)[2] | ((byte*)&dlugosc_trasy)[3] )!=0) {  //dlugosc_trasy!=0
				policz_srednia_trasy();
				pisz_uint(wl_dlug_trasy);
//				pisz_uint((((((trasa_czas_wtrysku*wl_dlug_trasy)/wspolczynnik_wtrysku)*ii*100)/dlugosc_trasy)*80)/wspolczynnik_dlugosci);
				LcdStr_d(&wynik[1]);   //od 1 bo najpierw spacja
				}
				else LcdStr ("  0.0");
				LcdStr("l/100km");



				break;
//=============================================================================
//         ekran dodatkowy 3 duze cyfry ilosci paliwa z baku
//=============================================================================

		case 3:



				LcdGotoXY(0x12);
				LcdStr("bak");
				policz_ilosc_paliwa_trasa();
				if (bak_paliwo>=bak_paliwo-trasa_ilosc_paliwa) bak_paliwo_temp=bak_paliwo-trasa_ilosc_paliwa;
				else bak_paliwo_temp=0;
				pisz_uint(bak_paliwo_temp);
				wynik[4]=wynik[3];
				wynik[3]='.';
				if (wynik[2]==' ') wynik[2]='0';
				size=1;
				wynik[5]='l';
				LcdStr_d(&wynik[0]);

 // moment krytyczny podatny na bledy zaokraglania
				wl_dlug_trasy=10000;
				ii=1;
				LcdGotoXY(0x14);
				if ( ( ((byte*)&trasa_czas_wtrysku)[0] | ((byte*)&trasa_czas_wtrysku)[1] ) !=0) {
					wl_dlug_trasy=100;
					ii=100;
				}
				policz_srednia_trasy();
//				wl_dlug_trasy=(((((trasa_czas_wtrysku*wl_dlug_trasy)/wspolczynnik_wtrysku)*ii*100)/dlugosc_trasy)*80)/wspolczynnik_dlugosci;
if ((((byte*)&dlugosc_trasy)[0] | ((byte*)&dlugosc_trasy)[1] | ((byte*)&dlugosc_trasy)[2] | ((byte*)&dlugosc_trasy)[3] )!=0) {  //dlugosc_trasy!=0


				pisz_ulong((bak_paliwo_temp*10/wl_dlug_trasy));	//dystans do przejechania na paliwie ze zbiornika
				LcdStr_d(&wynik[6]);
				LcdChr(' ');

				}
				else {
					LcdStr ("??");
					wl_dlug_trasy=0;
						 }
				LcdStr("km");


				LcdGotoXY(0x16);
				pisz_uint(wl_dlug_trasy);
				LcdStr_d(&wynik[2]);   //od 1 bo najpierw spacja

				size=0;
				LcdStr("l/100km");

				break;


//=============================================================================
//         ekran dodatkowy 4 dodatkowe informacje
//=============================================================================

	case 4:
				LcdGotoXY(0x11);
				LcdStr("DrogaC");

//                    impuls             cm/impuls           aby uzyskac z dokladnoscia 1km
				pisz_ulong((dlugosc_calkowita/10) * wspolczynnik_dlugosci/80000);
				LcdStr_d(&wynik[4]); 	//od 4 bo spacja rozdzielajaca
				LcdStr("km");

				LcdGotoXY(0x12);
				LcdStr("ZuzycC ");

//                    256*impuls             256*impuls/0.1l
				pisz_uint(((ogolne_ilosc_paliwa)/wspolczynnik_wtrysku));
				LcdStr_d(&wynik[0]);
				LcdChr('l');


				LcdGotoXY(0x13);
				LcdStr("SrC");

if ((((byte*)&dlugosc_calkowita)[0] | ((byte*)&dlugosc_calkowita)[1] | ((byte*)&dlugosc_calkowita)[2] | ((byte*)&dlugosc_calkowita)[3] )!=0) {   //dlugosc_calkowita!=0
//                     256*impuls             256*impuls/0.1l           impuls             cm/impuls           aby uzyskac z dokladnoscia 1km
				 pisz_uint(((ogolne_ilosc_paliwa/wspolczynnik_wtrysku)*100000)/((dlugosc_calkowita/10) * wspolczynnik_dlugosci/80));
				 LcdStr_d(&wynik[1]);
}
				else LcdStr ("  0.0");
				LcdStr("l/100km");

				LcdGotoXY(0x14);
				LcdStr("==============");

				LcdGotoXY(0x15);
				LcdStr("Chw.");
				pisz_uint(predkosc_chwilowa);
				LcdStr_d(&wynik[0]);	//od zera bo spacja rozdzielajaca
				LcdStr("km/h");

				LcdGotoXY(0x26);
	 //w silnikach 4 cylindrowych trzeba * 2
				pisz_ulong(pam_chwilowe_obroty*120);
				LcdStr_d(&wynik[6]);
				LcdStr(" obr/min");

				break;

	default: nr_ekranu=0;
 				pisz_ekran=1;
				break;
	}

}

// -------------------------------

void czytaj_klawisz (void)
{
		EA=0; //zablokuj przerwania
		ii=nacisniety_klawisz;
		nacisniety_klawisz=brak_klawisza;
 		EA=1; //odblokuj przerwania
}

void init_proc (void)
{
//---------------------------------------------------------------------------
//           inicjalizacja ukladow wewnetrznych procesora
//---------------------------------------------------------------------------
// inicjalizacja petli PLL

	PLLCON = 0;		//maksymalna czestotliwosc zegara

// inicjalizacja timera TIC

	TIMECON = 0x13; //00010011
	INTVAL = 1;  //przerwanie co 1s


	TCON = 0x54; 		//01010100 	ext1-edge, tr1 on,tr0 on
	TMOD = 0x29;		//0010 1001 8bit auto reload timer1, gate,mode1 timer0

	TH1=255-158;				//3300Hz

// inicjalizacja timera 2 do generowania przerwan co 20ms
#if test==0
	RCAP2L =0x15; //przerwanie co 20ms
  RCAP2H =0xae;
#endif
#if test==1
	RCAP2L =0x1; //przerwanie co 60ms
  RCAP2H =0x00;
#endif

	T2CON =0x0c; 		//00001100


//	SCON=0x40;		//01000000 UART mode1

// inicjalizacja przerwan

	IE = 0x24;   		//00100100  timer2 ,ext1, wszystkie zablokowane
	IP = 0;		    	//00000000
	IEIP2 = 0x4;  	//00000100  TIC

 WDWR=1;
 WDCON=0x72;   // Enable Watchdog timer to cause
               // 2.0 second timeout period
		      	   // enable WDIR bit to generate
		      	   // a reset and not an interrupt
 EA=1;

// Configure ADC

		ADCMODE=0x23;    // ENABLE PRIMARY Mode - continuous conversion
//    ADC1CON=0x20;    // USE INTERNAL REFERENCE
                    // PTAT(+) --> PTAT(-)
                    // BIPOLAR MODE
                    // Fixed +/- 2.5V range
    ADC0CON=0x0f;   //00001111
										// USE INTERNAL REFERENCE
										// AIN1/AIN2
                    // UNIPOLAR MODE
                    // Fixed 2.5V range
//	 ICON=0x00;				//00000000
										// na razie bedziemy mierzyli wgledem masy

//---------------------------------------------------------------------------
}

//*********************************************************************
//           program glowny
//*********************************************************************

void main(void)  {                // PROGRAM GLOWNY

// zmienne poza idata zerowane przy starcie (wiec takze pola bitowe)
// 	menu_on=0;				//menu wylaczone po starcie
// 	czuwaj=0;				//zaczynamy od pracy
//	nr_menu=0;
//  nr_ekranu=0;
//  postoj=0;

//	akt_hour=0;
//	akt_min=0;
//	akt_sek=0;
	led_lcd=1;	//wlaczenie podswietlenia wyswietlacza
//	nacisniety_klawisz=brak_klawisza;
	poprz_znak=' ';
	akt_znak=' ';

// pobieramy z eepromu aktualny wspolczynnik drogi i wspolczynnik wtrysku

	EADRL=pocz_danych_eeprom;
	ECON=FLASH_READ;

	wspolczynnik_dlugosci=212;  // 26.5 * 8
	if (( EDATA2 != 255 )&&( EDATA2 != 0 )) wspolczynnik_dlugosci=EDATA2;

	max_czas_przerw=30;		//standardowy czas przerwy to 30 min
	if ( EDATA3 != 255 )	max_czas_przerw=EDATA3;

//	zamiana=1;  //po starcie wyzerowana
	if ( EDATA4!=0 ) zamiana=1;

	EADRL=pocz_danych_eeprom+1;
	ECON=FLASH_READ;

	wspolczynnik_wtrysku=49050;
	if ((EDATA1 & EDATA2)!=255) {
		((byte*)&wspolczynnik_wtrysku)[0]=EDATA1;
		((byte*)&wspolczynnik_wtrysku)[1]=EDATA2;
	}

	bak_paliwo=0;
	if ((EDATA3 & EDATA4)!=255) {
		((byte*)&bak_paliwo)[0]=EDATA3;
		((byte*)&bak_paliwo)[1]=EDATA4;
	}

//		dlugosc_calkowita=0;		//globalnie zerowane
		EADRL=pocz_danych_eeprom+2;
		ECON=FLASH_READ;
//	if ((EDATA1 & EDATA2 & EDATA3 & EDATA4)!=255) {
		((byte*)&dlugosc_calkowita)[0]=EDATA1;
		((byte*)&dlugosc_calkowita)[1]=EDATA2;
		((byte*)&dlugosc_calkowita)[2]=EDATA3;
		((byte*)&dlugosc_calkowita)[3]=EDATA4;
//	}
//		ogolne_ilosc_paliwa=0;		//globalnie zerowane
		EADRL=pocz_danych_eeprom+3;
		ECON=FLASH_READ;
//	if ((EDATA1 & EDATA2 & EDATA3 & EDATA4)!=255) {
		((byte*)&ogolne_ilosc_paliwa)[0]=EDATA1;
		((byte*)&ogolne_ilosc_paliwa)[1]=EDATA2;
		((byte*)&ogolne_ilosc_paliwa)[2]=EDATA3;
		((byte*)&ogolne_ilosc_paliwa)[3]=EDATA4;
//	}

	init_proc();

 	LcdInit();

	LcdClear();

 while ( 1 ) {                   // PETLA GLOWNA


	EA=0;
	WDWR=1;             // refresh watchdog timer
	WDE=1;
	EA=1;

		if ( menu_on && !czuwaj) 	obsluga_menu();

	if (!menu_on && !czuwaj) {

		czytaj_klawisz();

		switch ( ii )	{
			case enter:	menu_on=1;
							 		zmiana=1;
									nr_podmenu=0;
									nr_menu=0;		//zawsze po wejsciu w programowanie ekran tras
									break;
			case gora:	nr_ekranu++;
									pisz_ekran=1;
									break;

			case dol:		nr_ekranu--;
									pisz_ekran=1;
									break;
			case esc: if ( postoj )  {
								czas_postoju=max_czas_przerw*60-1;  //zeby byla 1s na pikniecie
								czas_pisk=15;		// pisk na 600ms
								ET1=1;         // wlacz
								}
								else
								if (nr_ekranu==4) {
				          dlugosc_calkowita=0;
									ogolne_ilosc_paliwa=0;
									czas_pisk=5;		// pisk na 200ms
									ET1=1;         // wlacz
								}
								break;
		}

	}


	if (jednasekunda==1) {
	 jednasekunda=0;			//zaznaczenie ze wykonujemy akcje

//----------------korekcja daty----------------------------

		if((HOUR==0) && (prev_hour==23)) {
    if(day>=max_day[month-1]) {  // ostatni dzien miesiaca
		  if(month==2 && year%4==0)  {    // luty i rok przestepny
				if(day==28)
				 day++;
				else {
				 day=1;
				 month++;
				}
		  }
		  else {   // inny miesiac
		    day=1;                      // rozpoczynamy nowy miesiac
		    if(month==12)  {  // grudzien
					month=1;
					year++;
			  }
				else
 		      month++;
		  }
		}
		else
	 	  day++;
  }
	prev_hour=HOUR;

//---------------------------------------------------------

	 led=!led;


	 if ( !czuwaj ) {  //DOTAD PROGRAM WYKONYWANY ZAWSZE

	 if ( !postoj ) {
		akt_sek++;
		if ( akt_sek==60 ) {
		 akt_sek=0;
		 akt_min++;
		}
		if ( akt_min==60 ) {
		 akt_min=0;
		 akt_hour++;
		}
	 }
//                       impuls             cm/impuls       aby uzyskac 0.1km/h
	 predkosc_chwilowa= (unsigned long)dlugosc_chwilowa*wspolczynnik_dlugosci*36/800;		//pomiar robiony co 1s

	 powyzej5km=0;
	 if ( predkosc_chwilowa > 50 ) powyzej5km=1;

	 if (max_predk_trasa<predkosc_chwilowa) max_predk_trasa=predkosc_chwilowa;

	  if (((SEC & 0x0f)==0) || (F1==1)) {
	 meastemp();		//pomiar temperatury i zachowanie w zmiennych tylko w czasie jazdy
		poprz_znak=akt_znak;

			if ( outdoor >= (temp1+3) ) {
					akt_znak=35;  // to jest znak / ze strzalka do gory
			}
			else {
				if ( outdoor <= (temp1-3) ) {
						akt_znak=92;       /* to jest znak \ ze strzalka w dol */
				}
				else {
						akt_znak='=';
				}
			}
	 	 	temp1=outdoor;
	 }

	if (!menu_on)	obsluga_ekranow();  //	poprzednio (!menu_on && !czuwaj)

	 postoj=!klucz_12V;

#if test==1
	 if ( (czas_postoju>5) )  // testowo 5s
#endif

#if test==0
	 if ( czas_postoju>max_czas_przerw*60 )  //max_czas_przerw*60 = xx minut
#endif
	{

// zapamietaj parametry trasy w EEPROMie bo to jej koniec
// zapamietanie nastapi tylko jezeli wystapilo niezerowe zuzycie paliwa

	 policz_dlugosc_trasy();
	 policz_ilosc_paliwa_trasa();

   if (bak_paliwo>=bak_paliwo-trasa_ilosc_paliwa) bak_paliwo=bak_paliwo-trasa_ilosc_paliwa;
	 else bak_paliwo=0;

 if ((((byte*)&trasa_ilosc_paliwa)[0] | ((byte*)&trasa_ilosc_paliwa)[1] )!=0) {
 EADRL=pocz_danych_eeprom;
 ECON=FLASH_READ;
 pom100=EDATA1;
 if ( pom100>=pocz_danych_eeprom ) pom100=0; //
 pom100=pom100+4;
 if ( pom100>=pocz_danych_eeprom ) pom100=0; //bufor rotacyjny
 ECON=FLASH_ERASE;
 EDATA1=pom100;
 ECON=FLASH_WRITE;

		EADRL=pom100;
		ECON=FLASH_ERASE; //kasowanie flasha
		EDATA1=pocz_year;
		EDATA2=pocz_month;
		EDATA3=pocz_day;
		EDATA4=pocz_hour;
		ECON=FLASH_WRITE; //zapis danych
		 pom100++;
		 EADRL=pom100;
	 	ECON=FLASH_ERASE; //kasowanie flasha
		EDATA1=pocz_min;
		EDATA2=akt_hour;
		EDATA3=akt_min;
		EDATA4=akt_sek;
		ECON=FLASH_WRITE; //zapis danych
		 pom100++;
		 EADRL=pom100;
	 	ECON=FLASH_ERASE; //kasowanie flasha
		EDATA1=((byte*)&trasa_ilosc_paliwa)[1]; // % 256;
		EDATA2=((byte*)&trasa_ilosc_paliwa)[0]; // / 256;
		EDATA3=((byte*)&wl_dlug_trasy)[1]; // % 256;
		EDATA4=((byte*)&wl_dlug_trasy)[0]; // / 256;
		ECON=FLASH_WRITE; //zapis danych
		 pom100++;
		 EADRL=pom100;
	 	ECON=FLASH_ERASE; //kasowanie flasha
		EDATA1=((byte*)&max_predk_trasa)[1]; // % 256;
		EDATA2=((byte*)&max_predk_trasa)[0]; // / 256;
		EDATA3=((byte*)&temp_pocz)[1]; // % 256;							//zapis temperatury zewnetrznej
		EDATA4=((byte*)&temp_pocz)[0]; // / 256;
	 	ECON=FLASH_WRITE; //zapis danych

		EADRL=pocz_danych_eeprom+1;
		ECON=FLASH_READ;
		ECON=FLASH_ERASE;
		EDATA3=((byte*)&bak_paliwo)[0];
		EDATA4=((byte*)&bak_paliwo)[1];
		ECON=FLASH_WRITE;

		EADRL=pocz_danych_eeprom+2;
		ECON=FLASH_ERASE;
		EDATA1=((byte*)&dlugosc_calkowita)[0];
		EDATA2=((byte*)&dlugosc_calkowita)[1];
		EDATA3=((byte*)&dlugosc_calkowita)[2];
		EDATA4=((byte*)&dlugosc_calkowita)[3];
		ECON=FLASH_WRITE;

		EADRL=pocz_danych_eeprom+3;
		ECON=FLASH_ERASE;
		EDATA1=((byte*)&ogolne_ilosc_paliwa)[0];
		EDATA2=((byte*)&ogolne_ilosc_paliwa)[1];
		EDATA3=((byte*)&ogolne_ilosc_paliwa)[2];
		EDATA4=((byte*)&ogolne_ilosc_paliwa)[3];
		ECON=FLASH_WRITE;
 }
		temp1=outdoor;
		czuwaj=1;
		ADCMODE=0;    // DISABLE PRIMARY
		LcdClear();
		F0=0;				//filtracja wlaczenia stacyjki
		ET1=0;			//brak dzwieku
//		RXD=0;
		TXD=0;
		PLLCON = 7;		//minimalna czestotliwosc zegara
	}
	 }
 else {
	if (klucz_12V & F0)	{
	PLLCON = 0;		//maksymalna czestotliwosc zegara
	TL0=0;
	TH0=0;
	akt_hour=0;
	akt_min=0;
	akt_sek=0;
	postoj=0;
	czuwaj=0;
	dlugosc_trasy=0;
	trasa_czas_wtrysku=0;
 	trasa_czas_wtrysku_l=0;
	max_predk_trasa=0;
	menu_on=0;
	nr_ekranu=0;
	pocz_hour=HOUR;
	pocz_min=MIN;
	pocz_day=day;
	pocz_month=month;
	pocz_year=year;
	pisz_ekran=1;
	akt_znak=' ';
	poprz_znak=' ';
	meastemp();		//pierwszy pomiar temperatury po przekreceniu kluczyka
	F1=1;					//zaznaczenie ze trzeba zapisac temperature
	ADCMODE=0x23;    // ENABLE PRIMARY Mode - continuous conversion
#if test==0
//		ADCMODE=0x15;    // full scale calibration
//		RDY1=0;
//		while ( !RDY1 ) {	}
//		RDY1=0;
//		ADCMODE=0x14;    // zero scale calibration
//		RDY1=0;
//		while ( !RDY1 ) {	}
//		RDY1=0;
#endif
	}
 else {
 	F0=klucz_12V;
	PCON=PCON | 0x12;  //wejdz w POWER DOWN
 }
 }
}
 else	{

 	if (!menu_on && !czuwaj && pisz_ekran)	obsluga_ekranow();
 }
 }

}


/*
--predkosc chwilowa
zasieg jazdy z baku
<<calkowita droga przejechana>>
<<srednia predkosc za calosc>>


		 ekran podstawowy
-chwilowe zuzycie paliwa
-calkowity czas jazdy w obecnej trasie
-napiecie w instalacji
-calkowita ilosc paliwa zuzyta w obecnej trasie
-calkowita dlugosc drogi przejechana w obecnej trasie
-temperatura zewnetrzna
-temperatura wewnetrzna



			ekran dodatkowy 1 (duze)
-calkowity czas jazdy w obecnej trasie									xx:xx:xx
-calkowita ilosc paliwa zuzyta w obecnej trasie         xx.xx l
-calkowita dlugosc drogi przejechana w obecnej trasie   xxx.x km

		 funkcje dodatkowe
--sygnalizacja potrzeby wlaczenia swiatel mijania
--sygnalizacja gololedzi


			ekran dodatkowy 2
-srednia predkosc w obecnej trasie                      xxx.x km/h
-maksymalna predkosc w obecnej trasie                   xxx.x km/h
-srednie zuzycie paliwa w obecnej trasie							 	xx.x l/100km


			ekran dodatkowy 3 (duze)
-ilosc paliwa w baku																	  xx.x l
-dystans do przejechania na paliwie z baku							xxx.x km
-srednie zuzycie paliwa w obecnej trasie							 	xx.x l/100km


			ekran dodatkowy 3 (duze)
-zuzycie calkowite																		  xx.x l
-dystans calkowity																			xxx.x km
-srednia calkowita																		 	xx.x l/100km

-predkosc chwilowa			                                xxx.x km/h
-obroty chwilowe																				xxxx obr/min


			 dane dla aktualnej trasy

-srednia predkosc w trasie
-maksymalna predkosc w trasie
-srednie zuzycie paliwa w trasie
-dlugosc przejechanej trasy
-czas przejazdu
-ilosc zuzytego paliwa
-data/godzina przejazdu

*/


